IDLIST ORG $F240

   PAGE ZERO POINTERS:

SPUSER * $00F2 USER STACK POINTER
POINT * $00FA CURRENT EA

   REGISTERS IN PIA-RAM:

SY * $1A69 SYN COUNTER
CHAR * $1A6B CHARACTER FROM TAPE
CHK * $1A6E CHECK SUM
SA * $1A70 START ADDRESS
GANG * $1A78 TEMP OF PBD-BITS
ID * $1A79 ID FROM TAPE
BRKT * $1A7C TERMINAL BREAK VECTOR

   PIA PORTS:

PAD * $1A80 PORT A DATA REGISTER
PADD * $1A81 PORT A DATA DIRECTION REGISTER
PBD * $1A82 PORT B DATA REGISTER
PBDD * $1A83 PORT B DATA DIRECTION REGISTER

   EXTERNAL ROUTINES:

RDBIT * $0BC2 READ BIT FROM TAPE
BTWEEN * $0BE8 DISPLAY BETWEEN CHARACTER
RDBYT * $0BF3 READ BYTE FROM TAPE
RDCH * $0C36 READ CHAR FROM TAPE
CHKSUM * $0C4B COMPUTE CHECKSUM
CHARVU * $0C5D SHOW CHAR ON 7 SEGMENT DISPLAY
VU * $0C64 SHOW SAME CHAR ON OTHER DISPLAY
LABJUN * $105F RETURN TO MONITOR-LOOP
CRLF * $11E8 PRINT CR+LF
PRBYT * $128F PRINT BYTE IN ACCU
RESTTY * $14BC RESTORE I/O SETTING
PRCHA * $1A53 VECTOR TO PRINT ROUTINE



INIT LDAIM RETURN TERMINAL BRK-VECTOR
 STA BRKT ON RETURN-TO-TOS ROUTINE
 LDAIM RETURN /
 STA BRKT +01
 JSR CRLF

RDTAPE LDAIM $32 INPUT RECORDER ON
 STA PBD OUTPUT RECORDER OFF, PB7 ENABLED
 STA GANG STROBE '9' ENABLED
 LDAIM $7E PB0 INPUT
 STA PBDD PB7 INPUT
 LDAIM $7F PA6..PA0 OUTPUT
 STA PADD
 LDAIM $00 SEGMENTS ON
 STA CHK RESET CHECKSUM
 STA CHK +01

SYNC LDAIM $FF RESET FOR SYNC CHAR
 STA CHAR

SYNCA BIT PAD BREAK?
 BPL RETJMP BACK TO TOS
 JSR RDBIT READ A BIT FROM TAPE
 ROR CHAR SHIFT BITS INTO CHAR
 LDA CHAR GET CURRENT CHAR
 JSR BTWEEN DISPLAY NO-SYNC CHAR
 CMPIM $16 SYN CHAR?
 BNE SYNCA IF NOT, GO ON TRYING
 LDYIM $0A TRY IT FOR TEN SYNCS AT LEAST
 STY SY

TENSYN BIT PAD BREAK?
 BPL RETJMP
 JSR RDCH GET CHAR FROM TAPE
 JSR CHARVU DISPLAY SYN CHAR
 CMPIM $16 STILL SYN CHAR?
 BNE SYNC IF NOT SEARCH AGAIN FOR SYNC'S
 DEC SY 10 SYNC'S RECEIVED?
 BNE TENSYNC GET MORE SYNC'S

STAR BIT PAD BREAK?
 BPL RETJMP
 JSR RDCH WAIT FOR *
 JSR CHARVU
 CMPIM '*
 BEQ STARA
 CMPIM $16 THEN STILL SYNC?
 BEQ STAR THEN WAIT FOR STAR
 BNE RDTAPE ELSE RESTART

STARA JSR CHARVU DISPLAY *
 JSR RDBYT READ ID
 STA ID SAVE ID
 JSR RDBYT READ SA LOWER BYTE
 JSR CHKSUM COMPUTE CHECKSUM
 STA SA SAVE SA
 STA POINT SAVE FOR COUNT TO EA
 JSR RDBYT READ SA HIGHER BYTE
 JSR CHKSUM COMPUTE CHECKSUM
 STA SA +01
 STA POINT +01
 JMP FILMEM

RETJMP JMP RETURN

FILMEM BIT PAD BREAK?
 BPL RETJMP
 JSR RDBYT READ DATA BYTE
 BMI CORDAT NOT A VALID HEX CHAR
 BEQ CHECK RDBYT RETURNS Z=1 IF EOF CHAR
 JSR CHKSUM
 INC POINT UPDATE EA
 BNE FMA
 INC POINT +01

FMA JSR VU DISPLAY *
 JMP FILMEM READ NEXT DATA BYTE

CHECK JSR RDBYT READ CHECKSUM
 PHA  HIDE CHECKSUM LOWER BYTE
 JSR RDBYT
 PHA  HIDE CHECKSUM HIGHER BYTE
 JSR RESTTY RESTORE I/O
 JSR IDSA PRINT ID AND SA
 LDA POINT +01
 JSR PRBYT PRINT EA
 LDA POINT
 JSR PRBYT
 SEC
 PLA  GET CHECKSUM HIGER BYTE
 SBC CHK +01 2 BYTE COMPARE
 PLA  GET LOWER BYTE
 SBC CHK
 BEQ AGN
 LDAIM $20
 JSR PRCHA PRINT A SPACE
 LDAIM '! PRINT A !
 JSR PRCHA

AGN JSR CRLF
 JMP RDTAPE START OVER AGAIN

CORDAT JSR RESTTY RETSORE I/O
 JSR IDSA PRINT ID AND SA
 LDXIM $04

PRSTAR LDAIM '?
 JSR PRCHA PRINT ???? !
 DEX
 BNE PRSTAR
 LDAIM $20
 JSR PRCHA
 LDAIM '!
 JSR PRCHA
 JMP AGN

IDSA LDA ID PRINT ID
 JSR PRBYT
 LDAIM $20 PRINT A SPACE
 JSR PRCHA
 LDA SA +01 PRINT SA
 JSR PRBYT
 LDA SA
 JSR PRBYT
 LDAIM $20 PRINT A SPACE
 JSR PRCHA
 RTS

RETURN JSR RESTTY RESTORE I/O

BRKTST BIT PAD
 BPL BRKTST BREAK KEY NOT RELEASED?
 LDAIM LABJUN RESTORE TERMINAL BRK VECTOR
 STA BRKT
 LDAIM LABJUN /
 STA BRKT +01
 LDAIM INIT SET RUN-VECTOR ON THIS PROGRAM
 STA POINT
 LDAIM INIT /
 STA POINT +01
 JMP LABJUN
