
   THE SUBROUTINE SHOW TRANSPORTS THE
   CONTENTS OF ANY DISPLAY BUFFER TO THE
   DISPLAY. THE X REGISTER IS USED AS A
   SCAN COUNTER. IT DETERMINES, IF POINTH,
   POINTL OR INH IS TRANSPORTED TO THE
   DISPLAY.

SHOW PHA  SAVE DISPLAY
 STY TEMP SAVE Y REGISTER
 LSRA
 LSRA  GET HIGH ORDER NIBBLE
 LSRA
 LSRA
 JSR CONVD OUTPUT HIGH ORDER NIBBLE
 PLA  GET DISPLAY AGAIN
 ANDIM $0F MASK OFF HIGH ORDER NIBBLE
 JSR CONVD OUTPUT LOW ORDER NIBBLE
 LDY TEMP RESTORE Y REGISTER
 RTS

   THE SUBROUTINE CONVD CONTROLS THE DISPLAY SCAN.
   IT CONVERTS THE CONTENTS OF THE DISPLAY BUFFER
   TO BE DISPLAYED INTO A SEGMENT PATTERN.

CONVD TAY  USE NIBBLE AS INDEX
 LDAAY LOOK FETCH SEGMENT PATTERN
 STA PAD OUTPUT SEGMENT PATTERN
 STX PBD OUTPUT DIGIT ENABLE
 LDYIM $7F
DELAY DEY  DELAY 500 US APPROX.
 BPL DELAY
 STY PAD TURN SEGMENTS OFF
 LDYIM $06
 STY PBD TURN DISPLAY OFF
 INX  ENABLE NEXT DIGIT
 INX
 RTS

   GETKEY CONVERTS A DEPRESSED KEY INTO A
   HEX NUMBER. IT RETURNS WITH THE KEY VALUE
   IN ACCU. IF AN INVALID KEY WAS DEPRESSED,
   THE ROUTINE RETURNS A $15 IN ACCU.

GETKEY LDXIM $21 START AT ROW 0
GETKEA LDYIM $01 GET ONE ROW
 JSR ONEKEY A=0, NO KEY DEPRESSED
 BNE KEYIN
 CPXIM $27
 BNE GETKEA EACH ROW SCANNED?
 LDAIM $15 RETURN IF INVALID KEY
 RTS
KEYIN LDYIM $FF
KEYINA ASLA  SHIFT LEFT UNTIL Y=KEY NUMBER
 BCS KEYINB
 INY
 BPL KEYINA
KEYINB TXA
 ANDIM $0F MASK MSD
 LSRA  DEVIDE BY 2
 TAX
 TYA
 BPL KEYIND
KEYINC CLC
 ADCIM $07 ADD ROW OFFSET
KEYIND DEX
 BNE KEYINC
 RTS

   RDINST TRANSFERS AN INSTRUCTION FROM KEYBOARD
   TO THE DISPLAY BUFFER. IT RETURNS WITH N=0 IF
   A COMMAND KEY WAS DEPRESSED. ONCE THE ENTIRE
   INSTRUCTION IS READ, RDINST RETURNS WITH N=1.

RDINST JSR GETBYT READ OPCODE
 BPL RDB RETURN IF COMMAND KEY
 STA POINTH STORE OPCODE IN DISPLAY BUFFER
 JSR LENACC COMPUTE INSTRUCTION LENGTH
 STY COUNT
 STY TEMPX
 DEC COUNT
 BEQ RDA 1 BYTE INSTRUCTION?
 JSR GETBYT IF NOT, READ FIRST OPERAND
 BPL RDB RETURN, IF COMMAND KEY
 STA POINTL STORE 1ST OPRAND IN DISPLAY BUFFER
 DEC COUNT
 BEQ RDA 2 BYTE INSTRUCTION?
 JSR GETBYT IF NOT, READ 2ND OPERAND
 BPL RDB RETURN IF COMMAND KEY
 STA INH STORE 2ND OPERAND IN DISPLAY BUFFER
RDA LDXIM $FF N=1
RDB RTS

   FILLWS TRANSFERS THE DATA FROM DISPLAY TO
   WORKSPACE. IT'S ALWAYS LEFT WITH Z=1

FILLWS JSR DOWN MOVE DOWN BY THE AM. IN BYTES
 JSR ADCEND ADJUST CURRENT END ADDRESS
 LDXIM $02
 LDYIM $00
WS LDAZX INH FETCH DATA FROM DISPLAY BUFFER
 STAIY CURADL INSERT DATA INTO DATA FIELD
 DEX
 INY
 CPY BYTES ALL INSERTED?
 BNE WS IF NOT, CONTINUE
 RTS


