
   BASICODE WRITE PROGRAM FOR JUNIOR COMPUTER
   WITH KB-9 BASIC

   DATE:14-6-'83

 ORG $0200

   POINTERS IN PAGE ZERO (BASIC)

INTER * $0004
BFRSPL * $007E BEGINNING OF FREE SPACE POINTER
BFRSPH * $007F
HIHEML * $0084 END OF RAM POINTER
HIHEMH * $0085

   6522-IC REGISTERS

TOCL * $1804 TIMER ONE COUNTER
TOCH * $1805
TOLL * $1806 TIMER ONE LATCH
TOLH * $1807
ACR * $180B AUXILIARY CONTROL REGISTER
IFR * $180D INTERRUPT FLAG REGISTER
IER * $180E INTERRUPT ENABLE REGISTER

   OUTPUT VECTOR (BASIC)

OUTVL * $2A52 OUTPUT VECTOR
OUTVH * $2A53

   TEMPORARY DATA BUFFERS

SOVL * $03F0
SOVH * $03F1
SAVINL * $03F2
SAVINH * $03F3
CHSUM * $03F4
DESTFL * $03FB

   EXTERNAL SUBROUTINE

MESSY * $0559

   :
   : INITIALISE POINTERS
   : TABLE ROUTINE STARTADDRESS TO OUTPUT VECTOR
   :

SAVE LDA OUTVL
 LDY OUTVH
 STA SOVL
 STY SOVH SAVE OUTPUT VECTOR
 LDAIM TABLE
 LDYIM TABLE /256
 STA OUTVL
 STY OUTVH NEW OUTPUT VECTOR
 LDA INTER
 LDY INTER +01
 STA SAVINL
 STY SAVINH SAVE INTER VECTOR
 LDAIM SVECAS
 LDYIM SVECAS /256
 STA INTER
 STY INTER +01 NEW INTER VECTOR
 LDA BFRSPL
 LDY BFRSPH
 STA STTABL +01 BEGINNING FREE SPACE POINTER
 STY STTABL +02 TO INDIRECT ADDRESSES STTABL AND
 STA LDTABL +01 LDTABL ( TABLE POINTERS )
 STY LDTABL +02
 LDAIM $00
 STA CHSUM CLEAR CHECKSUM
 STA DESTFL CLEAR DESTROY FLAG
 LDAIM $02 START OF TEXT CHARACTER

   :
   : THIS ROUTINE IS CALLED BY BASIC AND PUTS THE
   : LISTING OF THE PROGRAM IN A TABLE
   :

TABLE CMPIM $0A
 BEQ OK SKIP LF'S
 ORAIM $80
STTABL STA $FFFF CHARACTER TO TABLE
 EOR CHSUM
 STA CHSUM UPDATE CHECKSUM
 INC STTABL +01 INCREMENT TABLE POINTER
 BNE OUTOFM
 INC STTABL +02
OUTOFM LDA HIHEMH
 CMP STTABL +02
 BNE OK NOT END OF RAM? THEN BRANCH
 LDA HIHEML
 CMP STTABL +01
 BNE OK
 LDAIM $FF
 STA DESTFL SET DESTROY FLAG
 LDA $0078      GO ON AT BEGINNING OF BASIC WORKSPACE
 STA STTABL +01  AND REWRITE BASIC PROGRAM BY TABLE
 LDA $0079
 STA STTABL +02
OK RTS

   :
   : PRORAM TO TAPE
   :

SVECAS PHA
 TYA
 PHA
 LDAIM $0D
 JSR TABLE CARRIAGE RETURN TO TABLE
 LDAIM $03
 JSR TABLE END OF TEXT TO TABLE
 LDA CHSUM
 JSR STTABL CHECKSUM TO TABLE (WITHOUT SETTING BIT7)
 LDAIM $7F
 STA IER SET INTERRUPT DISABLE MODE
 LDAIM $C0
 STA ACR SET SQUARE WAVE OUTPUT (PB7)
 LDAIM $01
 STA TOCH START TIMER ONE
 JSR HEADER
LOADTA JSR ZERO STARTBIT=0
LDTABL LDA $FFFF
 LDYIM $08 BITCOUNTER=0
OUTCHA LSRA  ONE BIT TO CARRY
 PHA
 BCS HIGH
 JSR ZERO ONE PERIOD OF 1200HZ (=0)
 BVS NEXT BRANCH ALWAYS
HIGH JSR ONE TWO PERIODS OF 2400HZ (=1)
NEXT PLA
 DEY
 BNE OUTCHA BITCOUNTER NOT ZERO THEN BRANCH
 JSR ONE STOPBIT=1
 JSR ONE STOPBIT=1
 INC LDTABL +01 INCREMENT TABLE POINTER
 BNE LDT
 INC LDTABL +02
LDT LDY LDTABL +02
 LDX LDTABL +01
 CPY HIHEMH
 BNE CMPARE NOT END OF RAM? THEN BRANCH
 CPX HIHEML
 BNE CMPARE
 LDA $0078
 STA LDTABL +01 GO ON AT BEGINNING OF BASIC WORKSPACE
 LDA $0079
 STA LDTABL +02
CMPARE CPY STTABL +02
 BNE LOADTA NOT END OF TABLE? THEN BRANCH
 CPX STTABL +01
 BNE LOADTA
 JSR HEADER
 STY ACR DISPLAY PB7
 LDA SAVINL
 LDY SAVINH
 STA INTER RESET INTER VECTOR
 STY INTER +01
 LDA SOVL
 LDY SOVH
 STA OUTVL RESET OUTPUT VECTOR
 STY OUTVH
 LDA DESTFL
 BEQ RTRN DESTROY FLAG NOT SET? THEN BRANCH
 LDA $0079 DESTROY BASIC PROGRAM IF DESTFL IS NOT SET
 STA $007B
 STA $007D
 STA $007F
 LDY $0078
 INY
 INY
 INY
 STY $007A
 STY $007C
 STY $007E
 LDAIM $00
 TAY
 STAIY $0078
 INY
 STAIY $0078
 LDYIM $2C
 JSR MESSY "NEW" MESSAGE
RTRN PLA
 TAY
 PLA
 JMP INTER -01 RETURN TO BASIC

   :
   : 5 SEC 2400HZ
   :

HEADER LDXIM $70 SET X AND Y REGISTER FOR
 LDYIM $17 12000 PERIODS OF 2400HZ (=5 SEC 2400HZ)
HDR JSR ONE TWO PERIODS OF 2400HZ
 DEX
 BNE HDR
 DEY
 BNE HDR
 RTS

   :
   : ZERO=ONE PERIOD OF 1200 HZ
   : ONE =TWO PERIODS OF 2400 HZ
   :

ZERO LDAIM $9F
 STA TOLL
 LDAIM $01
 STA TOLH SET TIMER ONE FOR 417 MICRO SEC.
 JMP PERIOD
ONE JSR SUBONE
SUBONE LDAIM $CE
 STA TOLL
 LDAIM $00
 STA TOLH SET TIMER ONE FOR 208 MICRO SEC.
PERIOD LDA TOCL CLEAR TIMER ONE INTERRUPT FLAG
PER BIT IFR
 BVC PER NOT TIME-OFF?
 LDA TOCL
PRD BIT IFR
 BVC PRD
 RTS
