DUMP ORG $6000

   I/O

PAD * $1A80 PORT A DATA REGISTER
PADD * $1A81 PORT A DATA DIRECTION
PBD * $1A82 PORT B DATA REGISTER
PBDD * $1A83 PORT B DATA DIRECTION

   TIMER

CNTA * $1AF4 CLK1T, DSBL TIMER IRQ
RDFLAG * $1AD4 READ FLAG, B7 IS TIMER FLAG

   ZERO-PAGE ADDRESS POINTER

POINTL * $00FE
POINTH * $00FF

   TEMPORARY BUFFERS & POINTERS

CHKL * $1A6E CHECKSUM
CHKH * $1A6F
SAL * $1A70 START ADDRESS
SAH * $1A71
EAL * $1A72 END ADRESS + 1
EAH * $1A73
SYNCT * $1A74
BITS * $1A75 AMOUNT OF BITS
GANG * $1A78 TEMP OF PBD-BITS
ID * $1A79

HIGHER * $7D 3600 HZ HALF PERIODE DELAY
LOWER * $C3 2400 HZ HALF PERIODE DELAY
FIRST * $03 TOGGLE 3 TIMES AT 3600 HZ
SECOND * $02 TOGGLE 2 TIMES AT 2400 HZ

 LDAIM $47 PBD PATTERN
 LDXIM $FF PBDD PATTERN
 STA PBD INPUT OFF, OUTPUT ON, STROBE DSBLD
 STA GANG SAVE BITS OF PBD
 LDAIM $00 PAD PATTERN
 LDXIM $7F PADD PATTERN
 STA PAD SEGMENTS ON, DISABLED
 STA CHKL RESET CHECKSUM
 STA CHKH
 LDA SAL INITIALIZE POINTER
 STA POINTL
 LDA SAH
 STA POINTH
 LDXIM $FF SET SYNC COUNTER
 STX SYNCT

SYNCS LDAIM $16 SYN CHARACTER
 JSR OUTCH OUTPUT 255 SYNCS
 DEC SYNCT
 BNE SYNCS

 LDAIM '* OUTPUT START CHARACTER
 JSR OUTCH
 LDA ID OUTPUT ID
 JSR OUTBT
 LDA SAL OUTPUT START ADDRESS
 JSR OUTBTC FIRST CHECKSUM COMPUTATION
 LDA SAH
 JSR OUTBTC

DATATR LDA POINTH
 CMP EAH ENTIRE FILE SAVED?
 BNE HEXDAT
 LDA POINTL
 CMP EAL
 BEQ DUMPED

HEXDAT LDYIM $00
 LDAIY POINTL FETCH CURRENT DATA BYTE
 JSR OUTBTC TRANSMIT CURRENT DATA BYTE
 INC POINTL
 BNE DATATR SET UP FOR NEXT DATA BYTE
 INC POINTH
 CLC
 BCC DATATR

DUMPED LDAIM '/ OUTPUT END OF DATA CHARACTER
 JSR OUTCH NO CHECKSUM COMPUTATION
 LDA CHKL OUTPUT CHECKSUM
 JSR OUTBT
 LDA CHKH
 JSR OUTBT
 LDAIM $04 EOT CHARACTER
 JSR OUTCH
 LDAIM $04 EOT CHARACTER
 JSR OUTCH

 RTS  RETURN FROM DUMP


OUTBTC TAY  SAVE ACCU
 CLC
 ADC CHKL CHECKSUM COMPUTATION
 STA CHKL
 LDA CHKH CHK +:= BYTE
 ADCIM $00
 STA CHKH
 TYA  RESTORE ACCU

OUTBT TAY  SAVE ACCU
 LSRA  GET UPPER NIBBLE
 LSRA
 LSRA
 LSRA
 JSR NIBOUT OUTPUT UPPER NIBBLE AS ASCII CHAR
 TYA  GET BYTE AGAIN
 ANDIM $0F GET LOWER NIBBLE
 JSR NIBOUT OUTPUT LOWER NIBBLE AS ASCII CHAR
 RTS

NIBOUT CMPIM $0A CONVERT A NIBBLE TO ASCII CHAR
 CLC
 BMI NIB
 ADCIM $07

NIB ADCIM $30

OUTCH LDXIM $08 SET UP FOR 8 BITS

 STX BITS

ONE LSRA  SHIFT OUT BIT BY BIT
 PHA  SAVE CHAR
 BCC ZERO
 JSR HIGH START AT 3600 HZ
 JSR LOW
 JSR LOW END AT 2400 HZ
 JMP ZRO

ZERO JSR HIGH START AT 3600 HZ
 JSR HIGH
 JSR LOW END AT 2400 HZ

ZRO PLA  GET CHARACTER AGAIN
 DEC BITS ALL BITS SHIFTED OUT
 BNE ONE
 RTS

HIGH LDXIM FIRST AMOUNT OF HALF PERIODS

HIG BIT RDFLAG TIME OUT?
 BPL HIG
 LDAIM HIGHER SET UP TIMER FOR SHORT PERIOD
 STA CNTA DISABLE TIMER IRQ, CLK1T
 LDA GANG
 EORIM $80 TOGGLE OUTPUT
 STA PBD
 STA GANG SAVE STATUS QUO
 DEX
 BNE HIG
 RTS

LOW LDXIM SECOND AMOUNT OF HALF PERIODES

LO BIT RDFLAG TIME OUT?
 BPL LO
 LDAIM LOWER SET UP TIMER FOR LONG PERIOD
 STA CNTA DISABLE TIMER IRQ, CLK1T
 LDA GANG
 EORIM $80 TOGGLE OUTPUT
 STA PBD
 STA GANG SAVE STATUS QUO
 DEX
 BNE LO
 RTS

