;   SYMBOLIC DISASSEMBLER
;
 .BA $0200
 .OS
 .ES
;
;   DATA LOC. DECLARATIONS
;
STEP .DE $5
PGM.PTR .DE $D3
LBL.PTR .DE $D5
PARTIAL .DE $E5
PTR.STRT .DE $E6
RUN.NU .DE $E8
END .DE $E9
FORMAT .DE $EB
LENGTH .DE $EC
LMNEM .DE $ED
RMNEM .DE $EE
YSAVE .DE $EF
PCL .DE $F0
PCH .DE $F1
LBL.IDX .DE $F2
TEMP .DE $F4
INVALID .DE $F5
LINE.NU .DE $F6
TXT.LOW .DE $100
LBL.LOW .DE $104
;
;   KIM SUBROUTINES
;
INCHR .DE $90
OUTVEC .DE $93
RAE.WARM .DE $C003
;
;   MACRO DEFINITIONS
;
!!!SZ .MD (ADR.1 ADR.2) ;SET ADR-Z PAGE
 LDA *ADR.1
 STA *ADR.2
 LDA *ADR.1+1
 STA *ADR.2+1
 .ME
;
!!!SA .MD (ADR.1 ADR.2) ;SET ADR-MEM TO Z PAGE
 LDA ADR.1
 STA *ADR.2
 LDA ADR.1+1
 STA *ADR.2+1
 .ME
;
;   GET SA AND EA
;
 NOP
 NOP
 NOP
 LDA #0
 STA *RUN.NU ;ZERO BIT-7
 STA *INVALID
 LDX #$12
MOVE1 LDA *$E5,X
 STA Z.STORE+1,X ;SAVE Z-PAGE
 DEX
 BPL MOVE1
;
 INX
 STX *PARTIAL
MSG3 LDA MESS3,X
 BEQ FIN.3
 JSR OUTVEC
 INX
 BNE MSG3
FIN.3 JSR INCHR
 CMP #'D'
 BEQ CONT
 CMP #'L'
 BNE GO.RAE
 LDY #$80
 STY *PARTIAL
 BNE CONT
;
GO.RAE JMP RAE.RTN
;
PASS2 LDX #0
MSG.4 LDA MESS4,X
 BEQ FIN.4
 JSR OUTVEC
 INX
 BNE MSG.4
FIN.4 LDY #$40
 STY *PARTIAL
;
CONT LDX #0
MSG1 LDA MESS1,X
 BEQ FIN.1
 JSR OUTVEC
 INX
 BNE MSG1
FIN.1 JSR INBYTE
 STA *PTR.STRT+1
 JSR INBYTE
 STA *PTR.STRT
 LDX #0
MSG2 LDA MESS2,X
 BEQ FIN.2
 JSR OUTVEC
 INX
 BNE MSG2
FIN.2 JSR INBYTE
 STA *END+1
 JSR INBYTE
 STA *END
;
 BIT *PARTIAL
 BVC PA.1
 LDA #0
 STA *PARTIAL
 JMP PA.2
;
;   DIS PROG
;
PA.1 SA (LBL.LOW PGM.PTR)
 BNE DIS.AS
START SA (TXT.LOW PGM.PTR)
 LDA #$95 ;SET START LINE NUMBER
 STA *LINE.NU
 LDA #0
 STA *INVALID
 STA *LINE.NU+1
 STA *TEMP
DIS.AS SZ (PTR.STRT PCL)
DSMBL JSR INST.DIS ;DISASS ANS DSPL INSTR
 JSR PCADJ
 STA *PCL
 STY *PCH ;UPDATE PCL,H TO NXT INSTR
 CPY *END+1
 BCC DSMBL ;PCH<END+1
 BNE SET.RUN ;PCH=END+1
 LDA *END
 CMP *PCL
 BCS DSMBL ;PCL<=END
SET.RUN BIT *RUN.NU ;CHECK BIT-7 FOR RUN
 BMI FINISH
PA.2 SZ (PGM.PTR LBL.PTR) ;SET END LABEL FILE
 LDA #$80
 STA *RUN.NU
 LDA *PARTIAL
 BEQ START
 JMP PASS2
;
FINISH JSR ASC.STORE ;MOVE POINTER UP 2
 LDA #0
 JSR A.STORE ;MARK ENF OF TEXT
RAE.RTN LDX #$12
MOVE2 LDA Z.STORE+1,X ;RESTORE Z-PAGE
 STA *$E5,X
 DEX
 BPL MOVE2
 NOP
 NOP
 NOP
 JMP RAE.WARM
;
INST.DIS BIT *RUN.NU
 BPL OP.CODE ;BIT-7=0
INC.LINE CLC
 SED
 LDA *LINE.NU
 ADC #STEP
 STA *LINE.NU
 JSR A.STORE
 LDA *LINE.NU+1
 BCC DIS.A
 ADC #0
DIS.A STA *LINE.NU+1
 JSR A.STORE
 CLD
 LDA *TEMP
 CMP #$60 ;RTS?
 BEQ COMMENT
 CMP #$4C ;JMP?
 BEQ COMMENT
 CMP #$6C ;(JMP)?
 BNE CK.LBL
COMMENT LDA *INVALID
 BNE CK.LBL ;IN DATA MODE
 LDA #$BB ;";"
 JSR A.STORE
 STA *TEMP
 BNE INC.LINE
;
CK.LBL JSR LABEL ;CHECK IF LABEL REQ.
 BCS NO.LBL ;NO
 LDA #'L
 JSR A.STORE
 LDA *PCH
 JSR ASC.STORE
 LDA *PCL
 JSR ASC.STORE
 LDA #0
 STA *INVALID
NO.LBL LDA #$20
 JSR A.STORE
OP.CODE LDA *INVALID
 BNE ERR
 LDX #0
 LDA (PCL,X) ;GET OPCODE
 TAY
 LSR A ;EVEN/ODD TEST
 BCC IEVEN
 LSR A ;TEST BIT-1
 BCS ERR ;XXXX XX11 INSTR INVALID
 CMP #$22
 BEQ ERR ;1000 1001 INSTR INVALID
 AND #$07 ;MASK 3 BITS FPR ADDR MODE &
 ORA #$80 ;ADD INDEX OFFSET
IEVEN LSR A ;LSB INTO CARRY FOR
 TAX ;LEFT/RIGHT TEST BELOW
 LDA MODE,X ;INDEX ADR MODE TABEL
 BCS RTMODE ;IF C=1 USE LSD FOR
 LSR A ;PRINT FORMAT INDEX
 LSR A
 LSR A
 LSR A
RTMODE AND #$F ;MASK FOR 4-BIT INDEX
 BNE GETFMT ;$0 FOR INVALID OPCODES
ERR LDY #$80 ;SUBSTITUTE $80 FOR INVALID OP
 LDA #0 ;SET PRINT FORMAT INDEX TO 0
GETFMT TAX
 LDA MODE2,X ;INDEX TO PRINT FORMAT TABLE
 STA *FORMAT ;SAVE FOR ADR FIELD FORMAT
 AND #$03 ;ASK 2-BIT LENGTH 0=1-BYTE
 STA *LENGTH ;1=2-BYTE 2=3-BYTE
 TYA ;OPCODE
 AND #$8F ;MASK FOR 1XXX 1010 TEST
 TAX ;SAVE IT
 TYA ;OPCODE TO 'A' AGAIN
 LDY #$03
 CPX #$8A
 BEQ MNNDX3
MNNDX1 LSR A
 BCC MNNDX3 ;FROM INDEX TO MNEM TABLE
 LSR A
MNNDX2 LSR A ;1XXX 1010->0010 1XXX
 ORA #$20 ;XXXX YY01->0011 1XXX
 DEY ;XXXY YY10->0011 0XXX
 BNE MNNDX2 ;XXXY Y100->0010 0XXX
 INY ;XXXX X000->000X XXXX
MNNDX3 DEY
 BNE MNNDX1
 LDX #$03 ;CHAR COUNT FOR MNEM PRINT
 TAY
 LDA MNEML,Y
 STA *LMNEM ;FETCH 3-CHAR MNEM
 LDA MNEMR,Y ;(PACKED IN TWO BYTES)
 STA *RMNEM
 BIT *RUN.NU
 BPL END.MNEM
PRMN1 LDA #$00
 LDY #$05
PRMN2 ASL *RMNEM
 ROL *LMNEM ;SHIFTS 5 BITS OF CHAR INTO 'A'
 ROL A ;(CLEAR CARRY)
 DEY
 BNE PRMN2
 ADC #$3F ;ADD '?' OFFSET
 CMP #$3F
 BNE =+5
 LDA #'.
 STA *INVALID
 JSR A.STORE ;OUTPUT A CHAR OF MNEM
 DEX
 BNE PRMN1
;
 LDA (PCL,X)
 STA *TEMP
;
 LDA #$20
 JSR A.STORE
;
 LDA *INVALID
 BEQ CK.BIT
 LDA #'$ ;YES OUTPUT AS A DATA BYTE
 JSR A.STORE
 LDA (PCL,X)
 PHA
 JSR ASC.STORE
 PLA
 AND #$7F
 CMP #$20
 BCC X.END
 PHA
 LDA #$20
 JSR A.STORE
 LDA #';
 JSR A.STORE
 PLA
 JSR A.STORE
X.END JMP END.LINE
;
CK.BIT LDA (PCL,X)
 CMP #$2C ;BIT?
 BNE END.MNEM
 LDA *PCH
 STA *YSAVE
 INC *PCL
 BNE =+3
 INC *PCH
 JSR LABEL
 DEC *PCL
 LDA *YSAVE
 STA *PCH
 BCS END.MNEM
 SEC
 LDA *PGM.PTR
 SBC #4
 STA *PGM.PTR
 BCS =+3
 DEC *PGM.PTR+1
 JMP ERR
;
END.MNEM LDX #$06 ;COUNT FOR 6 PRINT FORMAT BITS
PRADR1 CPX #$03
 BNE PRADR3 ;IF X=3 PRINT ADR VAL
 LDY *LENGTH
 BEQ PRADR3 ;NO PRINT IF LENGTH=0
 LDA *FORMAT
 CMP #$E8 ;HANDLE REL ADR MODE
 BCS RELADR ;PRINT TARGET ADR
 LDA #'L
 CPY #2
 BEQ PRADR2
 BIT *RUN.NU
 BPL CK.REL
 LDA #'$
PRADR2 JSR A.STORE
BYTE2 LDA (PCL),Y
 JSR ASC.STORE
 DEY ;MORE SIGN BYTE FIRST
 BNE BYTE2
PRADR3 BIT *RUN.NU
 BPL PRADR4
 LDA *FORMAT
 LSR A
 BCC NZERO
 CMP #$09
 BCS NZERO
 LDA #'*
 JSR A.STORE
NZERO ASL *FORMAT ;TEST NXT PRNT FORMAT BIT
 BCC PRADR4 ;IF 0, NO PRINT
 LDA CHAR1-1,X ;CORRESP CHARS
 JSR A.STORE ;OUTPT 1 OR 2 CHRS
 LDA CHAR2-1,X ;(IF CHAR FROM CHAR2=0
 BEQ PRADR4 ;DONT PRINT IT
 JSR A.STORE
PRADR4 DEX
 BNE PRADR1
 BIT *RUN.NU
 BPL RTS1
 BMI END.LINE
CK.REL LDA *FORMAT
 CMP #$1D
 BNE RTS1
RELADR LDA (PCL),Y
 JSR PCADJ2 ;PCL,H+DISPL+1 TO 'A',Y
 TAX
 INX
 BNE PRNTYX ;+1 TO 'X','Y'
 INY
PRNTYX TYA
PRNTAX PHA
 LDA #'L
 JSR A.STORE
 PLA
 JSR ASC.STORE ;PRNT TRGT ADDS OF BRANCH
PRNTX TXA ;AND RETURN
 JSR ASC.STORE
 BIT *RUN.NU
 BPL RTS1
 BMI END.LINE
PCADJ LDA *LENGTH ;0=1-,1=2-,2=3-BYTE
 SEC
PCADJ2 LDY *PCH
 TAX ;TEST DISPL SIGN (FOR REL
 BPL PCADJ3 ;BRANCH) EXTEND NEG
 DEY ;BY DECREMENT PCH
PCADJ3 ADC *PCL
 BCC RTS1 ;PCL+LENGTH (OR DISPL)+1 TO 'A'
 INY ;CARRY INTO 'Y' (PCH)
RTS1 RTS
;
END.LINE LDA #$A0 ;MARK EOL
 JSR A.STORE
 RTS
;
ASC.STORE PHP
 BIT *RUN.NU
 BPL A.STORE+1
 PHA
 LSR A
 LSR A
 LSR A
 LSR A
 JSR NIBASC
 JSR A.STORE
 PLA
 JSR NIBASC
 JSR A.STORE
 PLP
 RTS
;
A.STORE PHP
 STY *YSAVE
 LDY #0
 STA (PGM.PTR),Y
 CLC
 INC *PGM.PTR
 BNE PG.RTN
 INC *PGM.PTR+1
PG.RTN PLP
 LDY *YSAVE
 RTS
;
;SUBROUTINE LABELS, RETURNS CARRY CLEAR IF MATCH
;
LABEL SA (LBL.LOW LBL.IDX)
 LDY #1 ;SKIP 'L'
 .BY $2C
NXT.LBL LDY #3 ;SKIP 2ND PART OF ADR & 'L'
NXT.CHR INC *LBL.IDX
 BNE NO.INC
 INC *LBL.IDX+1
NO.INC DEY
 BNE NXT.CHR
 LDA *PCH
 CMP (LBL.IDX),Y
 BNE CK.END
 INY
 LDA *PCL
 CMP (LBL.IDX),Y
 BNE CK.END
 CLC ;LABEL MATCH FOUND
 RTS
CK.END LDA *LBL.IDX
 CMP *LBL.PTR
 BCC NXT.LBL ;ACC < MEM FOR BR
 LDA *LBL.IDX+1
 CMP *LBL.PTR+1
 BCC NXT.LBL
 RTS ;CARRY SET FOR RETURN WITHOUT MATCH
;
;   TABLES FOLLOW:
;
MODE .BY $40 $02 $45 $03 $D0 $08 $40 $09 $30
;   XXXX XXZ0 INSTRUCTIONS
 .BY $22 $45 $33 $D0 $08 $40 $09 $40 $02 $45
;      Z=0, LEFT HALF BYTE
;      Z=1, RIGHT HALF BYTE
 .BY $33 $D0 $08 $40 $09 $40 $02 $45 $B3 $D0
 .BY $08 $40 $09 $00 $22 $44 $33 $D0 $8C $44
 .BY $00 $11 $22 $44 $33 $D0 $8C $44 $9A $10
 .BY $22 $44 $33 $D0 $08 $40 $09 $10 $22 $44
 .BY $33 $D0 $08 $40 $09 $62
;   YYXX XZ01 INSTRUCTIONS
 .BY $13 $78 $A9
MODE2 .BY $00;ERR
 .BY $21;IMM
 .BY $01;Z-PAGE
 .BY $02;ABS
 .BY $00;IMPL
 .BY $80;ACC
 .BY $59;(Z-PAGE,X)
 .BY $4D;(Z-PAGE),Y
 .BY $11;Z-PAGE,X
 .BY $12;ABS,X
 .BY $06;ABS,Y
 .BY $4A;(ABS)
 .BY $05;Z-PAGE,Y
 .BY $1D;REL
CHAR1 .BY $2C $29 $2C $23 $28 $41
CHAR2 .BY $59 $00 $58 $00 $00 $00
;   XXXX X000 INSTRUCTIONS
MNEML .BY $1C $8A $1C $23 $5D $8B $1B $A1 $9D
 .BY $8A $1D $23 $9D $8B $1D $A1 $00 $29 $19
 .BY $AE $69 $A8 $19 $23 $24 $53 $1B $23
 .BY $24 $53 $19 $A1 $00
;   XXXY Y100 INSTRUCTIONS
 .BY $1A $5B $5B $A5 $69 $24 $24
;   XXXX 1010 INSTRUCTIONS
 .BY $AE $AE $A8 $AD $29 $00 $7C $00
;   XXXY YY10 INSTRUCTIONS
 .BY $15 $9C $6D $9C $A5 $69 $29 $53
;   XXXX YY01 INSTRUCTIONS
 .BY $84 $13 $34 $11 $A5 $69 $23 $A0
;   XXXX X000 INSTRUCTIONS
MNEMR .BY $D8 $62 $5A $48 $26 $62 $94 $88
 .BY $54 $44 $C8 $54 $68 $44 $E8 $94 $F4 $B4
 .BY $08 $84 $74 $B4 $28 $6E $74 $F4 $CC $4A
 .BY $72 $F2 $A4 $8A
;   XXXY Y100 INSTRUCTIONS
 .BY $F4 $AA $A2 $A2 $74 $74 $74 $72
;   1XXX 1010 INSTRUCTIONS
 .BY $44 $68 $B2 $32 $B2 $F4 $22 $F4
;   XXXY YY10 INSTRUCTIONS
 .BY $1A $1A $26 $26 $72 $72 $88 $C8
;   XXXY YY01 INSTRUCTIONS
 .BY $C4 $CA $26 $48 $44 $44 $A2 $C8
;
MESS1 .BY $0D $0A 'START ADDRESS =$' $00
MESS2 .BY $0D $0A 'END ADDRESS =$' $00
MESS3 .BY $0D $0A 'DISASSEMBLE, LABELS FIRST'
 .BY $0D $0A 'OR RETURN TO RAE (D,L OR R)?' $00
MESS4 .BY $0D $0A 'PASS 2' $00
;
ASCHEX CMP #$40
 BMI VALALFA
 CLC
 ADC #$09
VALALFA AND #$0F
 RTS
;
INBYTE JSR INCHR
 JSR ASCHEX
 ASL A
 ASL A
 ASL A
 ASL A
 PHA
 JSR INCHR
 JSR ASCHEX
 STA $1A6B
 PLA
 ORA $1A6B
 RTS
;
;
NIBASC AND #$0F
 CMP #$0A
 BCS NIBALF
 ADC #$30
 BCC Z.STORE
NIBALF ADC #$36
Z.STORE RTS
 .EN
