
   BASICODE READ PROGRAM FOR JUNIOR COMPUTER
   WITH SYM BASIC

   DATE:7-4-'84

LOADBC ORG $0400

   POINTERS IN PAGE ZERO (BASIC)

VEADL * $0081 BEGINNING OF FREE SPACE POINTER
VEADH * VEADL +01
HIHEML * $0087 END OF RAM POINTER
HIHEMH * HIHEML +01

   6522-IC REGISTERS

PCR * $180C PERIPHERAL CONTROL REGISTER
IFR * $180D INTERRUPT FLAG REGISTER
IER * $180E INTERRUPT ENABLE REGISTER

   6532-IC REGISTERS

PAD * $1A80 DATA REGISTER OF PORT A
PBD * $1A82 DATA REGISTER OF PORT B
CNTB * $1AF5 CLK8T (INTERRUPT DISABLE)
CNTC * $1AF6 CLK64T (INTERRUPT DISABLE)

   INPUT VECTOR (BASIC)

INVECL * $C390 INPUT VECTOR
INVECH * INVECL +01

   TEMPORARY DATA BUFFERS

CHSUM * $03F4 CHECKSUM
PRCNTL * $03F5 PERIOD COUNTER
PRCNTH * $03F6
ZERO * $03F7 PERIODTIME
HLFPTM * $03F8 HALF PERIODTIME
SIVL * $03F9
SIVH * $03FA

   EXTERNAL SUBROUTINE

PRCHA * $0D0B PRINT CHARACTER ROUTINE

   :
   : INITIALISE AND RECEIVE
   :

READ LDAIM $7F
 STA IER SET INTERRUPT DISABLE MODE
 LDAIM $00
 STA PCR SET CA1 NEGATIVE EDGE DETECT
 STA CHSUM CLEAR CHECKSUM
 LDAIM $73
 STA PBD
 LDA VEADL      BEGINNING OF FREE SPACE POINTER
 STA STAIND +01  TO INDIRECT ADDRESS STAIND
 LDX VEADH
 INX  256 BYTE FOR EXTENSION
 CPX HIHEMH
 BCS STOP
 STX STAIND +02

HEADER LDAIM $10
 STA PRCNTH SET PERIOD COUNTER
 LDAIM $36
 JSR NOSYNC DISPLAY NOSYNC CHARACTER
HDR JSR PERIOD
 CMPIM $22
 BCC HEADER PERIODTIME << 2400 PERIODTIME
 CMPIM $4E
 BCS HEADER PERIODTIME >> 2400 PERIODTIME
 INC PRCNTL
 BNE HDR NOT 256 PERIODS? THEN BRANCH
 TAY
 JSR SYNC DISPLAY SYNC CHARACTER
 TYA
 DEC PRCNTH 
 BNE HDR NOT 16*256 PERIODS OF 2400 HZ? THEN BRANCH
 ASLA  PERIDTIME X 2 (=1200 HZ PERIODTIME )
 SEC
 SBCIM $0C 1200HZ PERIODTIME - 100 US = ZERO
 STA ZERO
STABIT JSR SYNC
 JSR HLFPER FIND STARTBIT
 CMP ZERO
 BCC STABIT NO 1200 HZ PERIOD? THEN BRANCH
 BCS READBY BRANCH ALWAYS
STRTBT JSR HLFPER FIND STARTBIT
 CMP ZERO
 BCC STRTBT
READBY JSR RBYT READ ONE BYTE

STAIND STA $FFFF CHARACTER TO TABLE
 CMPIM $03
 BEQ EOT END OF TEXT CHARACTER? THEN BRANCH
 INC STAIND +01 INCREMENT POINTER
 BNE EORAM
 INC STAIND +02
EORAM LDA HIHEMH
 CMP STAIND +02
 BNE STRTBT NOT END OF RAM? THEN BRANCH
 LDA HIHEML
 CMP STAIND +01
 BNE STRTBT
STOP LDYIM $00
 JSR MESSY "OUT OF MEMORY" MESSAGE
 LDAIM $67
 STA PBD
 RTS  RETURN TO BASIC

EOT JSR HLFPER
 CMP ZERO
 BCC EOT
 JSR RBYT READ CHECKSUM
 LDAIM $67
 STA PBD
 LDA VEADL TABLE STARTADDRESS TO LDIND
 STA LDIND +01
 LDX VEADH
 INX
 STX LDIND +02
 LDA INVECL
 LDY INVECH
 STA SIVL SAVE INPUT VECTOR
 STY SIVH
 LDAIM LDIND
 LDYIM LDIND /256
 STA INVECL NEW INPUT VECTOR
 STY INVECH
 RTS

   :
   : THIS ROUTINE IS CALLED BY BASIC AND TRANSFERS
   : EVERY CHARACTER FROM THE TABLE TO BASIC
   : IT ALSO GIVES A LISTING OF THE PRAGRAM
   :

LDIND LDA $FFFF CHARACTER FROM TABLE
 TAY
 JSR PRCHA
 INC LDIND +01 INCREMENT POINTER
 BNE INCPNT
 INC LDIND +02
INCPNT LDA STAIND +02
 CMP LDIND +02
 BNE RETBAS NOT END OF TABLE? THEN BRANCH
 LDA STAIND +01
 CMP LDIND +01
 BNE RETBAS
 LDA SIVL
 STA INVECL RESET INPUT VECTOR
 LDA SIVH
 STA INVECH
 LDA CHSUM
 BEQ RETURN NO CHECKSUM ERROR? THEN BRANCH
 LDYIM $12
 JSR MESSY "CHECKSUM ERROR" MESSAGE
RETURN LDYIM $25
 JSR MESSY "OK" MESSAGE
 LDAIM $0D CARRIAGE RETURN
 RTS
RETBAS TYA
 RTS

   :
   : MEASURE ONE PERIODTIME
   :

PERIOD JSR HLFPER
HLFPER LDAIM $02
HLF BIT IFR
 BEQ HLF NO ACTIVE EDGE ON CA1-INPUT? THEN BRANCH
 STA IFR CLEAR CA1 INPUT
 LDAIM $01
 EOR PCR
 STA PCR OPPOSITE ACTIVE CA1 EDGE DETECT
 LDAIM $FF
 TAX
 EOR CNTC GET ELAPSED TIME IN ACCU
 STX CNTB RESET TIMER
 TAX
 CLC
 ADC HLFPTM FULL PERIODTIME IN ACCU
 STX HLFPTM SAVE LAST HALF PERIODTIME
 RTS

   :
   : READ ONE BYTE
   :

RBYT LDAIM $55
 JSR NOSYNC
 LDYIM $08 SET BITCOUNTER
RB PHA  SAVE ACCU
 JSR PERIOD
 CMP ZERO
 BCS FNDZRO 1200HZ PERIOD? THEN BRANCH
 JSR PERIOD SECOND 2400HZ PERIOD
 SEC
 BCS SHIFT BRANCH ALWAYS
FNDZRO CLC
SHIFT PLA
 RORA  NEXT BIT TO ACCU
 DEY
EB BNE RB NOT 8 BITS? THEN BRANCH
 PHA
 EOR CHSUM
 STA CHSUM UPDATE CHECKSUM
 PLA
 ANDIM $7F CLEAR BIT 7
 RTS

   :
   : DISPLAY SYNC-CHARACTER ON 7-SEGM.DISPLAY
   :

SYNC LDAIM $69
NOSYNC STA PAD
 LDA PBD
 EORIM $02
 STA PBD
 RTS

   :
   : OUTPUT MESSAGE (MESS+Y)
   :

MESSY LDAAY MESS LOAD CHARACTER
 CMPIM $03
 BEQ MESEND END OF TEXT CHARACTER?
 JSR PRCHA
 INY
 JMP MESSY
MESEND RTS

MESS = $0D
 = $0A
 = 'O
 = 'U
 = 'T
 = ' 
 = 'O
 = 'F
 = ' 
 = 'M
 = 'E
 = 'M
 = 'O
 = 'R
 = 'Y
 = $0A
 = $0D
 = $03
 = $0D
 = $0A
 = 'C
 = 'H
 = 'E
 = 'C
 = 'K
 = 'S
 = 'U
 = 'M
 = ' 
 = 'E
 = 'R
 = 'R
 = 'O
 = 'R
 = $0A
 = $0D
 = $03
 = $0D
 = $0A
 = 'O
 = 'K
 = $0A
 = $0D
 = $03
 = $0D
 = $0A
 = 'N
 = 'E
 = 'W
 = $0A
 = $0D
 = $03
